/**************************************************************************
   FILE         : propagate_2.c
   SNNS VERSION : 2.1

   PURPOSE      : pattern propagation demo-example using C neural networks
                  performed by runtime.c to propagate patterns which are 
		  read from stdin

   NOTES        : This source may be copied and modified appropriatly 
                  by the user
 
   AUTHOR       : Michael Vogt
   VERSION      : 1.0
   CHANGED BY   : 

   DATE         : 20.07.93

             Copyright (c) 1990-1993  SNNS Group, IPVR, Univ. Stuttgart, FRG

*****************************************************************************/

#include <stdio.h>
#include "runtime.h"


main()
{
    float    InPattern[NO_OF_IN_UNITS], OutPattern[NO_OF_OUT_UNITS];
    int err;
    int i;

    err = Init_Net(); 
    if (err)
    {
	printf ("%s", err_chk(err));
	exit (1);
    }
    
    printf("Please type in %d float values as input for the network %s\n",
	   NO_OF_IN_UNITS, NET_NAME);
    
    for (i=0; i<NO_OF_IN_UNITS; i++)
    {
	scanf("%f", &InPattern[i]);
    }
    
    err = Propagate_Pattern(InPattern, OutPattern);
    if (err)
    {
	printf ("%s", err_chk(err));
	exit (1);
    }
    
    printf("The result is:\n");
    for (i=0; i<NO_OF_OUT_UNITS; i++)
    {
	printf("%g ", OutPattern[i]);
    }
    printf("\n");
    printf("Here is what could have been written to another log file:\n\n");
    
    err= Write_Pattern(stdout, InPattern, OutPattern);
    if (err)
    {
	printf ("%s", err_chk(err));
	exit (1);
    }
}
