/**************************************************************************
  FILE          : snns2c.h
  SNNS VERSION  : 2.1

  PURPOSE       : constant definitions needed  by snns2c.c to convert
                  ascii network (.net) file to C source codes runtime.c 
                  and runtime.h
                   
  NOTES         : 

  AUTHOR        : Kais Brahim
  VERSION       : 1.0
  CHANGED BY    : Dietmar Posselt (05.07.93)

  DATE          : 15.11.1992

             Copyright (c) 1990-1993  SNNS Group, IPVR, Univ. Stuttgart, FRG

*****************************************************************************/


/* Errors */

#define  ERR_NO	               0
#define  ERR_MEMORY            1
#define  ERR_OUTFUNC           2
#define  ERR_ACTFUNC           3
#define  ERR_UPDFUNC           4
#define  ERR_SITEFUNC          5
#define  ERR_IO                6
#define  ERR_EOF               7
#define  ERR_FILE_FORMAT       8
#define  ERR_FILE_OPEN         9
#define  ERR_SYNTAX            10
#define  ERR_TTYPE             11
#define  ERR_NO_LINKS          12
#define  ERR_NO_SITE_TYPES     13
#define  ERR_NO_UNIT_TYPES     14
#define  ERR_NO_UNITS          15
#define  ERR_OLD_VERSION       16
#define  ERR_FILE_C_OPEN       18
#define  ERR_FILE_H_OPEN       19

#define  LIN_MAX               125
#define  EOS                   '\0'    
#define  VERSION_3D            "-3D"

#define  TRUE                  1
#define  FALSE                 0

#define  runtime_c             "runtime"
#define  runtime_h             "runtime"
#define  funcs_file0           "snns2c.src1"
#define  funcs_file1           "snns2c.src2"




/*****************************************************************


	  strings for generation of runtime.c and runtime.h


******************************************************************/


#define export_prototypes "\n\
typedef float  *Patterns; \n\n\
#ifdef _STDC_ \n\n\
int Init_Net (void);\n\
int Load_Pattern_File (FILE *pat_file, Patterns *in_patterns,\n\
                                        Patterns *out_patterns);\n\
int Propagate_Pattern_Array (Patterns in_patterns,\n\
                            Patterns out_pattern);\n\
int Propagate_Pattern (float *in_pattern, float *out_pattern);\n\
int Write_Pattern_Arrays (FILE *filehandle, int start_pattern,\n\
                          Patterns in_pat, Patterns out_pat);\n\
int Write_Pattern (FILE *filehandle, float *in_pattern,\n\
                                    float *out_pattern);\n\
char *err_chk(int err);\n\n\
#else \n\n\
int Init_Net();\n\
int Load_Pattern_File();\n\
int Propagate_Pattern_Array();\n\
int Propagate_Pattern();\n\
int Write_Pattern_Arrays();\n\
int Write_Pattern();\n\
char *err_chk();\n\n\
#endif\n\
\n\n"


#define   unit_func "\n\n/* read unit definition section */\n\n\
void Init_Units()\n\
{\n\
   char str[40] ,st;\n\
   int i, no;\n\
   float flt;\n\
   bool SIT;\n\n\
   FunctionPtr      func_ptr;\n\n\
   struct FtypeUnitStruct *F_ptr;\n\
   struct SiteTable *site_entry;\n\
   struct Site *site_ptr, *ftype_site;\n\n\n"



#define conn_func "void Init_Connect()\n\
{\n\
   struct Link *link_ptr;\n\n\
   link_ptr = link_array;\n\n\n"



#define net_init "\n/***********************************************************************\n\n\
\t\t\tNet Initialization Functions\n\n\
************************************************************************/\n\n\n"




#define site_func "/* read the site type definition section */\n\n\
void Init_SiteTypes()\n\
{\n\
    int i;\n\
    struct SiteTable *site_ptr;\n\
    FunctionPtr func_ptr;\n\n\n\
    site_ptr = site_array;\n\n"



#define  utype_func "/* read unit type definition section */\n\n\
void Init_UnitTypes()\n\
{\n\
    int i;\n\
    char site_name[50], str[50];\n\n\
    FunctionPtr  func_ptr;\n\
    struct FtypeUnitStruct *F_ptr;\n\n\
    struct SiteTable *site_entry;\n\
    struct Site *site_ptr;\n\n\n\
    F_ptr = FTypeEntry;\n\n"

#define initnet_func  "net_error Init_Net()\n\
{\n\
   struct Unit *unit_ptr;\n\
   extern void UPDATE_CPNPropagate();\n\n\n\
   AllocMem();\n\n"

#define  unittype_call  "   if(NO_OF_UNIT_TYPES)\n\
   Init_UnitTypes();\n"

#define sitetype_call  "   if (NO_OF_SITE_TYPES)\n\
   Init_SiteTypes();\n\n"

#define  c_include  "#include <stdio.h>\n\
#include <string.h>\n\
#include <ctype.h>\n\
#include <time.h>\n\
#include <varargs.h>\n\n\
#include <math.h>\n\n\
#include \"runtime.h\"\n\n"

#define prototypes "\
char *err_chk();\n\
net_error Init_Net();\n\
void Init_SiteTypes();\n\
void Init_UnitTypes();\n\
void Init_Units();\n\
void Init_Connect();\n\
struct Unit *set_CurrentUnit();\n\
void Set_Site();\n\
void Set_SiteEntry();\n\
void Set_FuncType();\n\
void Set_Unit();\n\
void Set_UnitTop();\n\
void *Set_Links();\n\
void  Sort_Net();\n\
void  clear_flags();\n\
void  DepthFirstT();\n\
void  TopoSortT();\n\
void  DepthFirstFF();\n\
void  TopoSortFF();\n\
void  TopoSortIHO();\n\
bool  NextInput();\n\
void  create_PatOutHeader();\n\
net_error Load_Pattern_File();\n\
void  Show_Pattern();\n\
net_error  Propagate_Pattern_Array();\n\
net_error  Propagate_Pattern();\n\
void  cutTrailingZeros();\n\
net_error  Open_Out_File();\n\
net_error  Write_Pattern_Arrays();\n\
net_error  Write_Pattern();\n\
net_error AllocMem();\n\
FlintType  OUT_Identity();\n\
FlintType  OUT_Clip_01( );\n\
FlintType  OUT_Clip_11( );\n\
FlintType  OUT_Threshold05( );\n\
FlintType  ACT_Linear();\n\
FlintType  ACT_MinOutPlusWeight();\n\
FlintType  ACT_TanHFunction();\n\
FlintType  ACT_Logistic();\n\
FlintType  ACT_Perceptron();\n\
FlintType  ACT_Signum();\n\
FlintType  ACT_Signum0();\n\
FlintType  ACT_StepFunction();\n\
FlintType  ACT_BAMFunction();\n\
FlintType  ACT_LogisticI();\n\
FlintType  RbfUnitGetNormsqr();\n\
FlintType  ACT_RBF_Gaussian();\n\
FlintType  ACT_RBF_Thinplatespline();\n\
FlintType  ACT_Linear_bias();\n\
FlintType  SITE_WeightedSum();\n\
FlintType  SITE_Product();\n\
FlintType  SITE_ProductA();\n\
FlintType  SITE_Max();\n\
FlintType  SITE_Min();\n\
void  UPDATE_syncPropagate();\n\
void  UPDATE_topologicalPropagate();\n\
void  UPDATE_serialPropagate();\n\
void  UPDATE_randomOrderPropagate();\n\
void  UPDATE_randomPermutPropagate();\n\
void  UPDATE_CPNPropagate();\n"











#define c_var  "FtypeArray        FTypeEntry;\n\
UnitArray         unit_array;\n\
STableArray       site_array;\n\
LinkArray         link_array;\n\n\
TopoPtrArray topo_ptr_array, topo_ptr;\n\n\
int          no_of_patterns = 0;\n\
bool         append = FALSE;\n\
net_error    error = 0;\n\n\n\
char              *patHeader[] = {\n\
\t/*pattern input file headers */\n\n\
\t\"SNNS pattern definition file %s\\n\",\n\
\t\"generated at\",\n\
\t\"No. of patterns     : %d\\n\",\n\
\t\"No. of input units  : %d\\n\",\n\
\t\"No. of output units : %d\\n\",\n\n\
\t/* pattern result file headers */\n\n\
\t\"SNNS result file\",\n\
\t\"startpattern        : \",\n\
\t\"No. of patterns     : \",\n\
\t\"No. of input units  : \",\n\
\t\"No. of output units : \",\n\
\t\"input patterns included\",\n\
\t\"input patterns excluded\",\n\
\t};\n\n\n"











