/**************************************************************************
  FILE           : snns2c_prot.h
  SNNS VERSION   : 2.1

  PURPOSE        : function prototypes for snns2c.c
  NOTES          : 


  AUTHOR         : Kais Brahim
  VERSION        : 1.0
  CHANGED BY     : Dietmar Posselt (05.07.93)

  DATE           : 15.11.1992

             Copyright (c) 1990-1993  SNNS Group, IPVR, Univ. Stuttgart, FRG

*****************************************************************************/

#ifdef __STDC__

void    err_chk(int err);

int     write_inchead(char *date, char *name);
int     write_chead(char *date,char *name);
int     write_cinclude(void);
int     write_def(void);
int     write_cvart(void);
int     write_cvar(void);

bool    SkipComments(void);
bool    MatchComma(void);
bool    GetNewLine(FILE *io_st);
bool    SkipSepar(void);
char    *getSection(char *line, int *title_no , char *Title[],
		     int *NoOfT, FILE *io_stream);

bool    SkipLine( int N );
bool    set_func(char **func_name);



void    ReadDefaults( FILE *stream );
void    ReadUnitDefinitions( FILE *stream);
void    ReadConnectionDefs( FILE *stream );
void    ReadSiteDefinitions( FILE * stream );
void    ReadTypeDefinitions(FILE    *stream);
void    SkipSubnetDefs( FILE    *stream);
void    SkipLayerDefs( FILE    *stream);


void    ScanHeader(FILE    *stream);
void    ScanGenNet( char *filename);
bool    getEntry(char    *line);
void    AppendFuncs(char file[50]);

#else 

void err_chk();

int write_inchead();
int write_chead();
int write_cinclude();
int write_def();
int write_cvart();
int write_cvar();

bool    SkipComments();
bool    MatchComma();
bool    GetNewLine();
bool    SkipSepar();
char    *getSection();

bool    SkipLine();
bool    set_func();



void    ReadDefaults();
void    ReadUnitDefinitions();
void    ReadConnectionDefs();
void    ReadSiteDefinitions();
void    ReadTypeDefinitions();
void    SkipSubnetDefs();
void    SkipLayerDefs();


void    ScanHeader();
void    ScanGenNet();
bool    getEntry();
void    AppendFuncs();

#endif 


